fehlerbehandlung - c# task tutorial




Mehrere Ausnahmen gleichzeitig erfassen? (17)

Es wird davon abgeraten, System.Exception einfach zu fangen. Stattdessen sollten nur die "bekannten" Ausnahmen abgefangen werden.

Nun führt dies manchmal zu unnötigem repetitivem Code, zum Beispiel:

try
{
    WebId = new Guid(queryString["web"]);
}
catch (FormatException)
{
    WebId = Guid.Empty;
}
catch (OverflowException)
{
    WebId = Guid.Empty;
}

Ich frage mich: Gibt es eine Möglichkeit, beide Ausnahmen zu WebId = Guid.Empty und den WebId = Guid.Empty Aufruf nur einmal aufzurufen?

Das angegebene Beispiel ist ziemlich einfach, da es nur eine GUID . Stellen Sie sich jedoch Code vor, bei dem Sie ein Objekt mehrfach ändern und wenn eine der Manipulationen auf eine erwartete Weise fehlschlägt, möchten Sie das object "zurücksetzen". Wenn es jedoch eine unerwartete Ausnahme gibt, möchte ich diese immer noch höher werfen.


Vorsicht und Warnung: Noch eine andere Art, funktionaler Stil.

Was in der Verknüpfung steht, beantwortet Ihre Frage nicht direkt, aber es ist trivial, sie so auszudehnen, dass sie wie folgt aussieht:

static void Main() 
{ 
    Action body = () => { ...your code... };

    body.Catch<InvalidOperationException>() 
        .Catch<BadCodeException>() 
        .Catch<AnotherException>(ex => { ...handler... })(); 
}

(Im Grunde eine weitere leere Catch Überladung, die sich selbst zurückgibt)

Die größere Frage ist, warum . Ich denke nicht, dass die Kosten hier überwiegen :)


@ Micheal

Leicht überarbeitete Version Ihres Codes:

catch (Exception ex)
{
   Type exType = ex.GetType();
   if (exType == typeof(System.FormatException) || 
       exType == typeof(System.OverflowException)
   {
       WebId = Guid.Empty;
   } else {
      throw;
   }
}

String Vergleiche sind hässlich und langsam.


Der Vollständigkeit halber kann der Code seit .NET 4.0 wie folgt umgeschrieben werden:

Guid.TryParse(queryString["web"], out WebId);

TryParse keine Ausnahmen aus und gibt false zurück, wenn das Format falsch ist und WebId auf Guid.Empty .

Seit C # 7 können Sie vermeiden, eine Variable in eine separate Zeile einzufügen:

Guid.TryParse(queryString["web"], out Guid webId);

Sie können auch Methoden zum Analysieren zurückliegender Tupel erstellen, die in .NET Framework ab Version 4.6 noch nicht verfügbar sind:

(bool success, Guid result) TryParseGuid(string input) =>
    (Guid.TryParse(input, out Guid result), result);

Und benutze sie so:

WebId = TryParseGuid(queryString["web"]).result;
// or
var tuple = TryParseGuid(queryString["web"]);
WebId = tuple.success ? tuple.result : DefaultWebId;

Das nächste unnütze Update auf diese nutzlose Antwort kommt, wenn die Dekonstruktion der Out-Parameter in C # 12 implementiert wird. :)


Die akzeptierte Antwort scheint akzeptabel zu sein, außer dass CodeAnalysis / FxCop sich darüber beschweren wird, dass es einen allgemeinen Ausnahmetyp erfasst.

Es scheint auch, dass der "Ist" -Operator die Leistung leicht verschlechtert.

CA1800: Wenn Sie nicht unnötigerweise casten , sollten Sie "das Ergebnis des 'als' Operator 'testen", aber wenn Sie das tun, schreiben Sie mehr Code, als wenn Sie jede Ausnahme separat abfangen.

Wie auch immer, hier ist was ich tun würde:

bool exThrown = false;

try
{
    // Something
}
catch (FormatException) {
    exThrown = true;
}
catch (OverflowException) {
    exThrown = true;
}

if (exThrown)
{
    // Something else
}

In C # 6 empfiehlt es sich, Exception-Filter zu verwenden, hier ein Beispiel:

 try
 {
      throw new OverflowException();
 }
 catch(Exception e ) when ((e is DivideByZeroException) || (e is OverflowException))
 {
       // this will execute iff e is DividedByZeroEx or OverflowEx
       Console.WriteLine("E");
 }

Nicht in C # leider, da Sie einen Ausnahmefilter benötigen, um es zu tun, und C # diese MSIL-Funktion nicht verfügbar macht. VB.NET hat diese Fähigkeit jedoch, z

Catch ex As Exception When TypeOf ex Is FormatException OrElse TypeOf ex Is OverflowException

Was Sie tun könnten, ist eine anonyme Funktion zu verwenden, um Ihren fehlerhaften Code einzukapseln und dann in diesen spezifischen catch-Blöcken aufzurufen:

Action onError = () => WebId = Guid.Empty;
try
{
    // something
}
catch (FormatException)
{
    onError();
}
catch (OverflowException)
{
    onError();
}

Wenn Sie Ihre Anwendung auf C # 6 aktualisieren können, haben Sie Glück. Die neue C # -Version hat Exception-Filter implementiert. So können Sie das schreiben:

catch (Exception ex) when (ex is FormatException || ex is OverflowException) {
    WebId = Guid.Empty;
}

Manche Leute denken, dass dieser Code derselbe ist

catch (Exception ex) {                
    if (ex is FormatException || ex is OverflowException) {
        WebId = Guid.Empty;
    }
    throw;
}

Aber es ist nicht. Eigentlich ist dies das einzige neue Feature in C # 6, das in früheren Versionen nicht emuliert werden kann. Erstens bedeutet ein erneuter Wurf mehr Aufwand, als den Fang zu überspringen. Zweitens ist es nicht semantisch äquivalent. Die neue Funktion bewahrt den Stapel intakt, wenn Sie Ihren Code debuggen. Ohne diese Funktion ist der Crash-Dump weniger nützlich oder sogar nutzlos.

Siehe dazu eine roslyn.codeplex.com/discussions/541301 . Und ein Beispiel, das den Unterschied zeigt .


Wenn Sie innerhalb der catch Bereiche keine if Anweisung verwenden möchten, können Sie in C# 6.0 Syntax für Exception Filters die bereits von der CLR in Vorschaufiles unterstützt wurde, aber nur in VB.NET / MSIL :

try
{
    WebId = new Guid(queryString["web"]);
}
catch (Exception exception) when (exception is FormatException || ex is OverflowException)
{
    WebId = Guid.Empty;
}

Dieser Code fängt die Exception nur ab, wenn es sich um eine InvalidDataException oder eine ArgumentNullException .

Tatsächlich können Sie in diese when Klausel grundsätzlich jede Bedingung einfügen:

static int a = 8;

...

catch (Exception exception) when (exception is InvalidDataException && a == 8)
{
    Console.WriteLine("Catch");
}

Beachten Sie, dass im Gegensatz zu einer if Anweisung im Gültigkeitsbereich des Exception Filters keine Exception Filters können. Wenn dies der true ist oder wenn die Bedingung nicht erfüllt ist, wird stattdessen die nächste catch Bedingung ausgewertet:

static int a = 7;

static int b = 0;

...

try
{
    throw new InvalidDataException();
}
catch (Exception exception) when (exception is InvalidDataException && a / b == 2)
{
    Console.WriteLine("Catch");
}
catch (Exception exception) when (exception is InvalidDataException || exception is ArgumentException)
{
    Console.WriteLine("General catch");
}

Ausgabe: Allgemeiner Fang.

Wenn es mehr als einen true Exception Filter gibt, wird der erste akzeptiert:

static int a = 8;

static int b = 4;

...

try
{
    throw new InvalidDataException();
}
catch (Exception exception) when (exception is InvalidDataException && a / b == 2)
{
    Console.WriteLine("Catch");
}
catch (Exception exception) when (exception is InvalidDataException || exception is ArgumentException)
{
    Console.WriteLine("General catch");
}

Ausgabe: Fang.

Und wie Sie in der MSIL der Code nicht in if Anweisungen übersetzt, sondern in Filters und Exceptions können nicht aus den mit Filter 1 und Filter 2 markierten Bereichen geworfen werden, sondern der Filter, der die Exception auslöst, wird stattdessen auch fehlschlagen Der Vergleichswert, der vor dem endfilter Befehl an den Stack endfilter wird, bestimmt den Erfolg / Fehler des Filters ( Catch 1 XOR Catch 2 wird entsprechend ausgeführt):

Außerdem hat Guid speziell die Guid.TryParse Methode.


Wie wäre es mit

try
{
    WebId = Guid.Empty;
    WebId = new Guid(queryString["web"]);
}
catch (FormatException)
{
}
catch (OverflowException)
{
}

Joseph Daigles Antwort ist eine gute Lösung, aber ich fand die folgende Struktur etwas aufgeräumter und weniger fehleranfällig.

catch(Exception ex)
{   
    if (!(ex is SomeException || ex is OtherException)) throw;

    // Handle exception
}

Es gibt einige Vorteile, den Ausdruck zu invertieren:

  • Eine Rückgabeanweisung ist nicht erforderlich
  • Der Code ist nicht verschachtelt
  • Es besteht keine Gefahr, die "throw" oder "return" Aussagen zu vergessen, die in Josephs Lösung vom Ausdruck getrennt sind.

Es kann sogar zu einer einzigen Linie verdichtet werden (wenn auch nicht sehr hübsch)

catch(Exception ex) { if (!(ex is SomeException || ex is OtherException)) throw;

    // Handle exception
}

Bearbeiten: Die Ausnahme-Filterung in C # 6.0 wird die Syntax ein wenig sauberer und bringt eine Reihe von anderen Vorteilen gegenüber jeder aktuellen Lösung. (Vor allem den Stapel unbeschadet lassen)

Hier ist, wie das gleiche Problem mit C # 6.0 Syntax aussehen würde:

catch(Exception ex) when (ex is SomeException || ex is OtherException)
{
    // Handle exception
}

In c# 6.0,Exception Filters is improvements for exception handling

try
{
    DoSomeHttpRequest();
}
catch (System.Web.HttpException e)
{
    switch (e.GetHttpCode())
    {
        case 400:
            WriteLine("Bad Request");
        case 500:
            WriteLine("Internal Server Error");
        default:
            WriteLine("Generic Error");
    }
}

Just call the try and catch twice.

try
{
    WebId = new Guid(queryString["web"]);
}
catch (FormatException)
{
    WebId = Guid.Empty;
}
try
{
    WebId = new Guid(queryString["web"]);
}
catch (OverflowException)
{
    WebId = Guid.Empty;
}

It is just that Simple!!


Note that I did find one way to do it, but this looks more like material for The Daily WTF :

catch (Exception ex)
{
    switch (ex.GetType().Name)
    {
        case "System.FormatException":
        case "System.OverflowException":
            WebId = Guid.Empty;
            break;
        default:
            throw;
    }
}

Since I felt like these answers just touched the surface, I attempted to dig a bit deeper.

So what we would really want to do is something that doesn't compile, say:

// Won't compile... damn
public static void Main()
{
    try
    {
        throw new ArgumentOutOfRangeException();
    }
    catch (ArgumentOutOfRangeException)
    catch (IndexOutOfRangeException) 
    {
        // ... handle
    }

The reason we want this is because we don't want the exception handler to catch things that we need later on in the process. Sure, we can catch an Exception and check with an 'if' what to do, but let's be honest, we don't really want that. (FxCop, debugger issues, uglyness)

So why won't this code compile - and how can we hack it in such a way that it will?

If we look at the code, what we really would like to do is forward the call. However, according to the MS Partition II, IL exception handler blocks won't work like this, which in this case makes sense because that would imply that the 'exception' object can have different types.

Or to write it in code, we ask the compiler to do something like this (well it's not entirely correct, but it's the closest possible thing I guess):

// Won't compile... damn
try
{
    throw new ArgumentOutOfRangeException();
}
catch (ArgumentOutOfRangeException e) {
    goto theOtherHandler;
}
catch (IndexOutOfRangeException e) {
theOtherHandler:
    Console.WriteLine("Handle!");
}

The reason that this won't compile is quite obvious: what type and value would the '$exception' object have (which are here stored in the variables 'e')? The way we want the compiler to handle this is to note that the common base type of both exceptions is 'Exception', use that for a variable to contain both exceptions, and then handle only the two exceptions that are caught. The way this is implemented in IL is as 'filter', which is available in VB.Net.

To make it work in C#, we need a temporary variable with the correct 'Exception' base type. To control the flow of the code, we can add some branches. Hier geht:

    Exception ex;
    try
    {
        throw new ArgumentException(); // for demo purposes; won't be caught.
        goto noCatch;
    }
    catch (ArgumentOutOfRangeException e) {
        ex = e;
    }
    catch (IndexOutOfRangeException e) {
        ex = e;
    }

    Console.WriteLine("Handle the exception 'ex' here :-)");
    // throw ex ?

noCatch:
    Console.WriteLine("We're done with the exception handling.");

The obvious disadvantages for this are that we cannot re-throw properly, and -well let's be honest- that it's quite the ugly solution. The uglyness can be fixed a bit by performing branch elimination, which makes the solution slightly better:

Exception ex = null;
try
{
    throw new ArgumentException();
}
catch (ArgumentOutOfRangeException e)
{
    ex = e;
}
catch (IndexOutOfRangeException e)
{
    ex = e;
}
if (ex != null)
{
    Console.WriteLine("Handle the exception here :-)");
}

That leaves just the 're-throw'. For this to work, we need to be able to perform the handling inside the 'catch' block - and the only way to make this work is by an catching 'Exception' object.

At this point, we can add a separate function that handles the different types of Exceptions using overload resolution, or to handle the Exception. Both have disadvantages. To start, here's the way to do it with a helper function:

private static bool Handle(Exception e)
{
    Console.WriteLine("Handle the exception here :-)");
    return true; // false will re-throw;
}

public static void Main()
{
    try
    {
        throw new OutOfMemoryException();
    }
    catch (ArgumentException e)
    {
        if (!Handle(e)) { throw; }
    }
    catch (IndexOutOfRangeException e)
    {
        if (!Handle(e)) { throw; }
    }

    Console.WriteLine("We're done with the exception handling.");

And the other solution is to catch the Exception object and handle it accordingly. The most literal translation for this, based on the context above is this:

try
{
    throw new ArgumentException();
}
catch (Exception e)
{
    Exception ex = (Exception)(e as ArgumentException) ?? (e as IndexOutOfRangeException);
    if (ex != null)
    {
        Console.WriteLine("Handle the exception here :-)");
        // throw ?
    }
    else 
    {
        throw;
    }
}

So to conclude:

  • If we don't want to re-throw, we might consider catching the right exceptions, and storing them in a temporary.
  • If the handler is simple, and we want to re-use code, the best solution is probably to introduce a helper function.
  • If we want to re-throw, we have no choice but to put the code in a 'Exception' catch handler, which will break FxCop and your debugger's uncaught exceptions.

This is a classic problem every C# developer faces eventually.

Let me break your question into 2 questions. The first,

Can I catch multiple exceptions at once?

In short, no.

Which leads to the next question,

How do I avoid writing duplicate code given that I can't catch multiple exception types in the same catch() block?

Given your specific sample, where the fall-back value is cheap to construct, I like to follow these steps:

  1. Initialize WebId to the fall-back value.
  2. Construct a new Guid in a temporary variable.
  3. Set WebId to the fully constructed temporary variable. Make this the final statement of the try{} block.

So the code looks like:

try
{
    WebId = Guid.Empty;
    Guid newGuid = new Guid(queryString["web"]);
    // More initialization code goes here like 
    // newGuid.x = y;
    WebId = newGuid;
}
catch (FormatException) {}
catch (OverflowException) {}

If any exception is thrown, then WebId is never set to the half-constructed value, and remains Guid.Empty.

If constructing the fall-back value is expensive, and resetting a value is much cheaper, then I would move the reset code into its own function:

try
{
    WebId = new Guid(queryString["web"]);
    // More initialization code goes here.
}
catch (FormatException) {
    Reset(WebId);
}
catch (OverflowException) {
    Reset(WebId);
}

Wanted to added my short answer to this already long thread. Something that hasn't been mentioned is the order of precedence of the catch statements, more specifically you need to be aware of the scope of each type of exception you are trying to catch.

For example if you use a "catch-all" exception as Exception it will preceed all other catch statements and you will obviously get compiler errors however if you reverse the order you can chain up your catch statements (bit of an anti-pattern I think) you can put the catch-all Exception type at the bottom and this will be capture any exceptions that didn't cater for higher up in your try..catch block:

            try
            {
                // do some work here
            }
            catch (WebException ex)
            {
                // catch a web excpetion
            }
            catch (ArgumentException ex)
            {
                // do some stuff
            }
            catch (Exception ex)
            {
                // you should really surface your errors but this is for example only
                throw new Exception("An error occurred: " + ex.Message);
            }

I highly recommend folks review this MSDN document:

Exception Hierarchy


catch (Exception ex)
{
    if (!(
        ex is FormatException ||
        ex is OverflowException))
    {
        throw;
    }
    Console.WriteLine("Hello");
}




exception-handling